package bin;

import kernel.peripherals.Peripherals.Peripheral;
import lib.CLIAppBase;

@:build(macros.Binstore.includeBin("Peripheral", ["ph", "peripheral"]))
class Perf extends CLIAppBase {
	public function new() {
		registerSyncSubcommand("inspect", (args) -> {
			if (args.length < 1)
				return false;

			var result = Peripheral.inspect(args[0]);

			if (result == null) {
				handle.writeLine("No peripheral found on side " + args[0]);
				return true;
			}

			handle.writeLine("Types:");
			for (type in result.types) {
				handle.writeLine("  " + type);
			}

			handle.writeLine("Methods:");
			for (method in result.methods) {
				handle.writeLine("  " + method);
			}

			return true;
		}, "<side>");

		registerSyncSubcommand("list", (args) -> {
			for (addr in Peripheral.getAllAddresses()) {
				handle.writeLine('$addr => ${Peripheral.getTypes(addr).join(", ")}');
			}
			return true;
		});
	}
}
