package bin.pathfinder;

import lib.Pos3;
import lib.ui.elements.IUIElement;
import lib.ui.elements.TextElement;
import lib.ui.elements.RootElement;
import kernel.ui.WindowContext;
import kernel.ps.ProcessHandle;
import kernel.ps.IProcess;

class PFClient implements IProcess {
	private var handle:ProcessHandle;

	private var ctx:WindowContext;
	private var requestRender:Void->Void;
	private var root:RootElement;

	public function new() {}

	public function run(handle:ProcessHandle) {
		this.handle = handle;

		var stateless = handle.createStatelessWindowContext();
		this.ctx = stateless.ctx;
		this.requestRender = stateless.requestRender;

		stateless.setRenderFunc(this.render);

		this.root = new RootElement();
		this.root.setTitle("Pathfinder");

		this.ctx.delegateEvents(this.root);

		this.requestRender();
	}

	private function render() {
		var acc = kernel.gps.GPS.getAccuracy();
		var pos:Pos3 = kernel.gps.GPS.getPosition() ?? {x: 0, y: 0, z: 0};

		var childre:Array<IUIElement> = [
			new TextElement('Acc: ${acc}'),
			new TextElement('Pos: X:${pos.x} Y:${pos.y} Z:${pos.z}'),
			new TextElement('UPDATE', {
				style: {bgColor: Gray},
				uiEvents: {
					onClick: () -> {
						kernel.gps.GPS.locate().handle((pos) -> {
							this.requestRender();
						});
					}
				}
			}),
		];

		this.root.setChildren(childre);
		this.root.render(ctx.getSize()).renderToContext(ctx);
	}
}
